/*Ghasssan Fakher
 * gkf01
section 4 */



public class Node {
	private int frequency;
	private char letter;
	private Node right;
	private Node left;
	
	
	public Node(int f, Node left, Node right, char l)
	{
		letter = l;
		frequency = f;
		this.right = right;
		this.left = left;
	}
	public Node(Node a)
	{
		frequency = a.getFrequency();
		this.right = a.getRight();
		this.left = a.getLeft();
		this.letter = a.getLetter();
	}
	
	public void setRight(Node right)
	{
		this.right = right;
	}
	public void setLeft(Node left)
	{
		this.left = left;
	}
	public void setFrequency(int f)
	{
		frequency = f;
	}
	public char getLetter()
	{
		return letter;
	}
	public Node getRight()
	{
		return right;
	}
	public Node getLeft()
	{
		return left;
	}
	public int getFrequency()
	{
		return frequency;
	}
	public String toString()
	{
		return "Frequency: " + frequency + "\n"  + "Letter " + letter + "\n" + "Right leaf: " + right + "\n" + "Left leaf: "  + left + "\n";
	}
	//used in order to sort the ArrayList in the building of the tree
	public int compareTo(Node o) {
		if(frequency > o.getFrequency())
			return 1;
		else if(frequency < o.getFrequency())
			return -1;
		else 
			return 0;
	}
}
