/*Ghassan Fakher
 * gkf01
 section 4*/

import java.awt.EventQueue;


import javax.swing.JFrame;
import javax.swing.JTextPane;
import java.awt.BorderLayout;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import java.awt.Color;
import javax.swing.JButton;
import javax.swing.LayoutStyle.ComponentPlacement;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.Font;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import java.awt.SystemColor;


public class CalculatorGui implements ActionListener {

	private JFrame frmCalculator;
	private JButton btn_Mr;
	private JButton btn_M;
	private JButton btnM_1;
	private JButton btn_Mc;
	private JButton btn_Ms;
	private JButton btnDel;
	private JButton btnC;
	private JButton button_leftParan;
	private JButton button_rightParan;
	private JButton button_equal;
	private JButton button_seven;
	private JButton button_eight;
	private JButton button_nine;
	private JButton button_divide;
	private JButton button_four;
	private JButton button_five;
	private JButton button_six;
	private JButton button_times;
	private JButton button_one;
	private JButton button_two;
	private JButton button_three;
	private JButton button_minus;
	private JButton button_zero;
	private JButton btn_point;
	private JButton button_plus;
	private JTextField textField;
	
	private static Calculator a;
	
	private static int memory = 0;
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		a = new Calculator();
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					CalculatorGui window = new CalculatorGui();
					window.frmCalculator.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public CalculatorGui() {
		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		frmCalculator = new JFrame();
		frmCalculator.setTitle("Calculator");
		frmCalculator.getContentPane().setBackground(SystemColor.activeCaptionBorder);
		frmCalculator.setBounds(250, 250, 320, 320);
		frmCalculator.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		btn_Mr = new JButton("MR");
		btn_Mr.setFont(new Font("Tahoma", Font.BOLD, 11));
		btn_Mr.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
			}
		});
		
		btn_M = new JButton("M+");
		btn_M.setFont(new Font("Tahoma", Font.BOLD, 11));
		
		btnM_1 = new JButton("M-");
		btnM_1.setFont(new Font("Tahoma", Font.BOLD, 11));
		
		btn_Mc = new JButton("MC");
		btn_Mc.setFont(new Font("Tahoma", Font.BOLD, 11));
		
		btn_Ms = new JButton("MS");
		btn_Ms.setFont(new Font("Tahoma", Font.BOLD, 11));
		
		btnDel = new JButton("Del");
		
		btnC = new JButton("C");
		
		button_leftParan = new JButton("(");
		
		button_rightParan = new JButton(")");
		
		button_equal = new JButton("=");
		
		button_seven = new JButton("7");
		
		button_eight = new JButton("8");
		
		button_nine = new JButton("9");
		
		button_divide = new JButton("/");
		
		button_four = new JButton("4");
		
		button_five = new JButton("5");
		
		button_six = new JButton("6");
		
		button_times = new JButton("*");
		
		button_one = new JButton("1");
		
		button_two = new JButton("2");
		
		button_three = new JButton("3");
		
		button_minus = new JButton("-");
		button_minus.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
			}
		});
		
		button_zero = new JButton("0");
		
		btn_point = new JButton(".");
		
		button_plus = new JButton("+");
		
		textField = new JTextField();
		textField.setColumns(10);
		GroupLayout groupLayout = new GroupLayout(frmCalculator.getContentPane());
		groupLayout.setHorizontalGroup(
			groupLayout.createParallelGroup(Alignment.LEADING)
				.addGroup(groupLayout.createSequentialGroup()
					.addContainerGap()
					.addGroup(groupLayout.createParallelGroup(Alignment.TRAILING)
						.addComponent(textField, Alignment.LEADING)
						.addGroup(Alignment.LEADING, groupLayout.createSequentialGroup()
							.addComponent(btnDel, GroupLayout.PREFERRED_SIZE, 61, GroupLayout.PREFERRED_SIZE)
							.addPreferredGap(ComponentPlacement.RELATED)
							.addComponent(btnC)
							.addPreferredGap(ComponentPlacement.RELATED)
							.addComponent(button_leftParan)
							.addPreferredGap(ComponentPlacement.RELATED)
							.addComponent(button_rightParan))
						.addGroup(Alignment.LEADING, groupLayout.createSequentialGroup()
							.addComponent(btn_Mc)
							.addPreferredGap(ComponentPlacement.RELATED)
							.addComponent(btn_Mr, GroupLayout.PREFERRED_SIZE, 58, GroupLayout.PREFERRED_SIZE)
							.addPreferredGap(ComponentPlacement.RELATED)
							.addComponent(btn_Ms)
							.addGap(4)
							.addComponent(btn_M)
							.addPreferredGap(ComponentPlacement.RELATED)
							.addComponent(btnM_1))
						.addGroup(Alignment.LEADING, groupLayout.createSequentialGroup()
							.addGroup(groupLayout.createParallelGroup(Alignment.LEADING, false)
								.addGroup(groupLayout.createSequentialGroup()
									.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
										.addComponent(button_four)
										.addComponent(button_one))
									.addPreferredGap(ComponentPlacement.RELATED)
									.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
										.addComponent(button_five)
										.addComponent(button_two))
									.addPreferredGap(ComponentPlacement.RELATED)
									.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
										.addComponent(button_six)
										.addComponent(button_three))
									.addPreferredGap(ComponentPlacement.RELATED)
									.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
										.addComponent(button_times)
										.addComponent(button_minus)))
								.addGroup(groupLayout.createSequentialGroup()
									.addComponent(button_zero, GroupLayout.PREFERRED_SIZE, 59, GroupLayout.PREFERRED_SIZE)
									.addPreferredGap(ComponentPlacement.UNRELATED)
									.addComponent(btn_point, GroupLayout.PREFERRED_SIZE, 52, GroupLayout.PREFERRED_SIZE)
									.addPreferredGap(ComponentPlacement.RELATED, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
									.addComponent(button_plus))
								.addGroup(groupLayout.createSequentialGroup()
									.addComponent(button_seven)
									.addPreferredGap(ComponentPlacement.RELATED)
									.addComponent(button_eight)
									.addPreferredGap(ComponentPlacement.RELATED)
									.addComponent(button_nine)
									.addPreferredGap(ComponentPlacement.RELATED)
									.addComponent(button_divide)))
							.addPreferredGap(ComponentPlacement.RELATED)
							.addComponent(button_equal, GroupLayout.PREFERRED_SIZE, 41, GroupLayout.PREFERRED_SIZE)))
					.addContainerGap(26, Short.MAX_VALUE))
		);
		groupLayout.setVerticalGroup(
			groupLayout.createParallelGroup(Alignment.LEADING)
				.addGroup(groupLayout.createSequentialGroup()
					.addContainerGap()
					.addComponent(textField, GroupLayout.PREFERRED_SIZE, 60, GroupLayout.PREFERRED_SIZE)
					.addPreferredGap(ComponentPlacement.RELATED)
					.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
						.addComponent(btn_Mc, GroupLayout.PREFERRED_SIZE, 33, GroupLayout.PREFERRED_SIZE)
						.addComponent(btn_Ms, GroupLayout.PREFERRED_SIZE, 32, GroupLayout.PREFERRED_SIZE)
						.addComponent(btn_M, GroupLayout.PREFERRED_SIZE, 32, GroupLayout.PREFERRED_SIZE)
						.addComponent(btn_Mr, GroupLayout.PREFERRED_SIZE, 33, GroupLayout.PREFERRED_SIZE)
						.addComponent(btnM_1, GroupLayout.PREFERRED_SIZE, 32, GroupLayout.PREFERRED_SIZE))
					.addPreferredGap(ComponentPlacement.RELATED)
					.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
						.addComponent(btnDel)
						.addComponent(btnC)
						.addComponent(button_leftParan)
						.addComponent(button_rightParan))
					.addPreferredGap(ComponentPlacement.RELATED)
					.addGroup(groupLayout.createParallelGroup(Alignment.TRAILING)
						.addGroup(groupLayout.createSequentialGroup()
							.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
								.addComponent(button_seven)
								.addComponent(button_eight)
								.addComponent(button_nine)
								.addComponent(button_divide))
							.addPreferredGap(ComponentPlacement.RELATED)
							.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
								.addComponent(button_five)
								.addComponent(button_four)
								.addComponent(button_six)
								.addComponent(button_times))
							.addPreferredGap(ComponentPlacement.RELATED, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
							.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
								.addComponent(button_minus)
								.addComponent(button_three)
								.addComponent(button_two)
								.addComponent(button_one))
							.addGap(8)
							.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
								.addComponent(button_zero)
								.addComponent(btn_point)
								.addComponent(button_plus, GroupLayout.PREFERRED_SIZE, 25, GroupLayout.PREFERRED_SIZE)))
						.addComponent(button_equal, GroupLayout.DEFAULT_SIZE, 114, Short.MAX_VALUE))
					.addGap(33))
		);
		frmCalculator.getContentPane().setLayout(groupLayout);
		button_one.addActionListener(this);
		button_two.addActionListener(this);
		button_three.addActionListener(this);
		button_four.addActionListener(this);
		button_five.addActionListener(this);
		button_six.addActionListener(this);
		button_seven.addActionListener(this);
		button_eight.addActionListener(this);
		button_nine.addActionListener(this);
		button_zero.addActionListener(this);
		btn_M.addActionListener(this);
		btn_Mc.addActionListener(this);
		btn_Mr.addActionListener(this);
		btn_Ms.addActionListener(this);
		btn_point.addActionListener(this);
		btnC.addActionListener(this);
		btnDel.addActionListener(this);
		btnM_1.addActionListener(this);
		button_times.addActionListener(this);
		button_divide.addActionListener(this);
		button_equal.addActionListener(this);
		button_plus.addActionListener(this);
		button_minus.addActionListener(this);
		button_rightParan.addActionListener(this);
		button_leftParan.addActionListener(this);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		// TODO Auto-generated method stub
		
		JButton b = (JButton)e.getSource();
		
			if(b == button_one)
				textField.setText(textField.getText() + "1");
			
			else if(b == button_two)
				textField.setText(textField.getText() + "2");
			
			else if(b == button_three)
				textField.setText(textField.getText() + "3");
			
			else if(b == button_four)
				textField.setText(textField.getText() + "4");
			
			else if(b == button_five)
				textField.setText(textField.getText() + "5");
			
			else if(b == button_six)
				textField.setText(textField.getText() + "6" );
			
			else if(b == button_seven)
				textField.setText(textField.getText() + "7");
			
			else if(b == button_eight)
				textField.setText(textField.getText() + "8");
			
			else if(b == button_nine)
				textField.setText(textField.getText() + "9");
			
			else if(b == button_zero)
				textField.setText(textField.getText() + "0");
			
			else if(b == button_minus)
				textField.setText(textField.getText() + " - ");
			
			else if(b == button_plus)
				textField.setText(textField.getText() + " + ");
			
			else if(b == button_times)
				textField.setText(textField.getText() + " * ");
			
			else if(b == button_divide)
				textField.setText(textField.getText() + " / ");
			
			else if(b == btn_point)
				textField.setText(textField.getText() + ".");
			
			else if(b == btnDel)	//remove the last character
			{
				if(textField.getText().length() > 0)
					textField.setText(textField.getText().substring(0, textField.getText().length() - 1));
			}
			else if(b == button_leftParan)
				textField.setText(textField.getText() + " ( ");
			
			else if(b == button_rightParan)
				textField.setText(textField.getText() + " ) ");
			
			else if(b == btn_M)
				memory += Integer.parseInt(textField.getText());
			
			else if(b == btn_Mc)	//restore the value of memory to 0
			{
				memory = 0;
				textField.setText("Memory cleared");
			}
			
			else if(b == btn_Mr)
				textField.setText(""+memory );
			
			else if(b == btn_Ms)	//the text must only be a number or else it will be wrong
				memory = Integer.parseInt(textField.getText());
			
			else if(b == btnM_1)
				memory -= Integer.parseInt(textField.getText());
			
			else if(b == btnC)
				textField.setText("");
			
			else if(b == button_equal)
			{
				String equation = textField.getText();
				textField.setText(a.calculate(a.convert(equation)) + "");
			}
	
	}
}
